Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | List of all members
LinearSourceForce Class Reference

Repellant force. More...

`#include "linearSourceForce.h"`

Inheritance diagram for LinearSourceForce:

## Public Member Functions
| LinearSourceForce ()
| Simple constructor.
| LinearSourceForce (const LinearSourceForce &copy)
| copy constructor
| LinearSourceForce (const LPoint3 &p, FalloffType f, PN_stdfloat r, PN_stdfloat a=1.0f, bool mass=true)
| Simple constructor.
virtual | ~LinearSourceForce ()
| Simple destructor.
virtual TypeHandle | force_init_type ()
virtual TypeHandle | get_type () const
virtual void | output (std::ostream &out) const
| Write a string representation of this instance to <out>.
virtual void | write (std::ostream &out, int indent=0) const
| Write a string representation of this instance to <out>.
Public Member Functions inherited from LinearDistanceForce
FalloffType | get_falloff_type () const
| falloff_type query
LPoint3 | get_force_center () const
| force_center query
PN_stdfloat | get_radius () const
| radius query
PN_stdfloat | get_scalar_term () const
| calculate the term based on falloff
void | set_falloff_type (FalloffType ft)
| falloff_type encapsulating wrap
void | set_force_center (const LPoint3 &p)
| set the force center
void | set_radius (PN_stdfloat r)
| set the radius
Public Member Functions inherited from LinearForce
| ~LinearForce ()
| Destructor.
PN_stdfloat | get_amplitude () const
bool | get_mass_dependent () const
LVector3 | get_vector (const PhysicsObject *po)
LVector3 | get_vector_masks ()
virtual bool | is_linear () const
void | set_amplitude (const PN_stdfloat a)
void | set_mass_dependent (bool m)
void | set_vector_masks (bool x, bool y, bool z)
Public Member Functions inherited from BaseForce
virtual | ~BaseForce ()
| destructor
bool | get_active () const
ForceNode * | get_force_node () const
NodePath | get_force_node_path () const
void | set_active (bool active)
Public Member Functions inherited from TypedReferenceCount
| TypedReferenceCount (const TypedReferenceCount &copy)
void | operator= (const TypedReferenceCount &copy)
Public Member Functions inherited from TypedObject
| TypedObject (const TypedObject &copy)=default
TypedObject * | as_typed_object ()
| Returns the object, upcast (if necessary) to a TypedObject pointer.
const TypedObject * | as_typed_object () const
| Returns the object, upcast (if necessary) to a TypedObject pointer.
int | get_best_parent_from_Set (const std::set< int > &) const
int | get_type_index () const
| Returns the internal index number associated with this object's TypeHandle, a unique number for each different type.
bool | is_exact_type (TypeHandle handle) const
| Returns true if the current object is the indicated type exactly.
bool | is_of_type (TypeHandle handle) const
| Returns true if the current object is or derives from the indicated type.
TypedObject & | operator= (const TypedObject &copy)=default
Public Member Functions inherited from MemoryBase
void | operator delete (void *, void *)
void | operator delete (void *ptr)
void | operator delete[] (void *, void *)
void | operator delete[] (void *ptr)
void * | operator new (size_t size)
void * | operator new (size_t size, void *ptr)
void * | operator new[] (size_t size)
void * | operator new[] (size_t size, void *ptr)
Public Member Functions inherited from ReferenceCount
int | get_ref_count () const
WeakReferenceList * | get_weak_list () const
| Returns the WeakReferenceList associated with this ReferenceCount object.
bool | has_weak_list () const
| Returns true if this particular ReferenceCount object has a WeakReferenceList created, false otherwise.
void | local_object ()
| This function should be called, once, immediately after creating a new instance of some ReferenceCount-derived object on the stack.
void | ref () const
| Explicitly increments the reference count.
bool | ref_if_nonzero () const
| Atomically increases the reference count of this object if it is not zero.
bool | test_ref_count_integrity () const
| Does some easy checks to make sure that the reference count isn't completely bogus.
bool | test_ref_count_nonzero () const
| Does some easy checks to make sure that the reference count isn't zero, or completely bogus.
virtual bool | unref () const
| Explicitly decrements the reference count.
bool | unref_if_one () const
| Atomically decreases the reference count of this object if it is one.
WeakReferenceList * | weak_ref ()
| Adds the indicated PointerToVoid as a weak reference to this object.
void | weak_unref ()
| Removes the indicated PointerToVoid as a weak reference to this object.

## Static Public Member Functions
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LinearDistanceForce
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from LinearForce
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from BaseForce
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()
Static Public Member Functions inherited from TypedObject
static TypeHandle | get_class_type ()
static void | init_type ()
| This function is declared non-inline to work around a compiler bug in g++ 2.96.
Static Public Member Functions inherited from ReferenceCount
static TypeHandle | get_class_type ()
static void | init_type ()

## Additional Inherited Members
Public Types inherited from LinearDistanceForce
enum | FalloffType { FT_ONE_OVER_R , FT_ONE_OVER_R_SQUARED , FT_ONE_OVER_R_CUBED }
Public Attributes inherited from TypedObject
| get_type
Public Attributes inherited from ReferenceCount
| get_ref_count
| Returns the current reference count.

## Detailed Description

Repellant force.

Definition at line 22 of file linearSourceForce.h.

## Constructor & Destructor Documentation

## ◆ LinearSourceForce() [1/3]

LinearSourceForce::LinearSourceForce | ( | const LPoint3 & | p,
|  | FalloffType | f,
|  | PN_stdfloat | r,
|  | PN_stdfloat | a = 1.0f,
|  | bool | mass = true )
| explicit

Simple constructor.

Definition at line 21 of file linearSourceForce.cxx.

Referenced by LinearSourceForce().

## ◆ LinearSourceForce() [2/3]

LinearSourceForce::LinearSourceForce | ( |  | ) |

Simple constructor.

Definition at line 30 of file linearSourceForce.cxx.

## ◆ LinearSourceForce() [3/3]

LinearSourceForce::LinearSourceForce | ( | const LinearSourceForce & | copy | ) |

copy constructor

Definition at line 39 of file linearSourceForce.cxx.

References LinearSourceForce().

## ◆ ~LinearSourceForce()

LinearSourceForce::~LinearSourceForce | ( |  | ) |
| virtual

Simple destructor.

Definition at line 47 of file linearSourceForce.cxx.

## Member Function Documentation

## ◆ force_init_type()

virtual TypeHandle LinearSourceForce::force_init_type | ( |  | ) |
| inline virtual

Reimplemented from LinearDistanceForce.

Definition at line 49 of file linearSourceForce.h.

## ◆ get_class_type()

static TypeHandle LinearSourceForce::get_class_type | ( |  | ) |
| inline static

Definition at line 38 of file linearSourceForce.h.

## ◆ get_type()

virtual TypeHandle LinearSourceForce::get_type | ( |  | ) | const
| inline virtual

Reimplemented from LinearDistanceForce.

Definition at line 46 of file linearSourceForce.h.

## ◆ init_type()

static void LinearSourceForce::init_type | ( |  | ) |
| inline static

Definition at line 41 of file linearSourceForce.h.

## ◆ output()

void LinearSourceForce::output | ( | std::ostream & | out | ) | const
| virtual

Write a string representation of this instance to <out>.

Reimplemented from LinearDistanceForce.

Definition at line 70 of file linearSourceForce.cxx.

## ◆ write()

void LinearSourceForce::write | ( | std::ostream & | out,
|  | int | indent = 0 ) const
| virtual

Write a string representation of this instance to <out>.

Reimplemented from LinearDistanceForce.

Definition at line 80 of file linearSourceForce.cxx.

References indent(), and LinearDistanceForce::write().

The documentation for this class was generated from the following files:

- panda/src/physics/linearSourceForce.h
- panda/src/physics/linearSourceForce.cxx